/*
 * FILE
 *	fsync.c
 *	
 * DESCRIPTION
 *	syncing filesystems, makes only sense with mint
 *	
 * BUGS
 *	fsync does the same as sync()
 */

#include <mintbind.h>

extern int errno;

__EXTERN int sync __PROTO ((void));

/*
 * FUNCTION
 *	int fsync(int fd)
 *	
 * DESCRIPTION
 *	sync all buffers related to file descriptor fd
 *  for now, just call the sync() function.
 */
int
__fsync(fd)
	int	fd;
{
	return sync();
}

#ifdef HAVE_WEAK_SYMBOLS
weak_alias (__fsync, fsync)
#endif

#ifdef TEST

/*
 * Im not in the mood to write a tricky test routine,
 * so just do 'cat junk1 >junk2;sync' from your shell
 * and listen to your harddisk.
 */
int
main()
{
	fsync(0xdead);
	return 0;
}

#endif
